#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
Paper into a summary
by Javantea
March 23, 2012 15:55:06.472745940 -0700
Update: July 4, 2012 15:34:28.869939705 -0700
Update: May 15, 2022
FIXME:
capital letters Porous vs porous
TODO: 
any file
html output with links to definitions
"""
import nltk, re
import string
import sys
import codecs
from lxml.html.clean import Cleaner
from lxml import html

def text_html(s):
	"""
	Convert an HTML document into a text document using lxml's Cleaner.
	"""
	if s == '' or s == None: return ''
	tree = html.fromstring(s)
	yclean = Cleaner()
	lclean_html = yclean.clean_html
	tree = lclean_html(tree)
	text = tree.text_content()
	return text
#end def text_html(s)

# UTF-8 output please.
#sys.stdout = codecs.getwriter('utf8')(sys.stdout)

if len(sys.argv) <= 1:
	print("Usage: histogram2.py filename.txt")
	print("Supports html files automatically if the file has extention htm or html")
	exit(1)
#end if
filename = sys.argv[1]

html = open(filename, 'rb').read()
if filename.endswith('.htm') or filename.endswith('.html'):
	raw = text_html(html)
else:
	raw = html
#raw = nltk.clean_html(html)
# This is the state of encoding today...
raw = raw.decode('utf-8').replace('&amp;', '&')
#replace('\xe2\x80\x9c', '"').replace('\xe2\x80\x9d', '"')

tokens = nltk.wordpunct_tokenize(raw) #nltk.word_tokenize(raw)
text = nltk.Text(tokens)

word_freq = nltk.FreqDist(tokens)

# FIXME: make this list dynamically or something based on WordNet or something.
unhelpful = [',', ';', 'of', 'and', 'the', '(', ')', 'a', '.', '[', ']', 'to', 
'for', 'in', 'that', 'by', 'is', 'with', 'be', 'on', 'we', '&amp', ':', 'can', 
'or', 'an', 'at', 'have', 'as', 'from', 'into', 'than', 'then', 'this', 'are', 
'were', 'also', 'not', 'these', 'using', 'was', '%', 'Figure', 'Journal', 
'CrossRef', '“', '”', '*', '–', '&', '=', '-', '|', 'Λ', '−', 'PDF']
abbrev = [x + '.' for x in string.ascii_uppercase]
unhelpful.extend(abbrev)
#nums = list(string.digits)
#unhelpful.extend(nums)

for word in unhelpful:
	if word in word_freq:
		del word_freq[word]
	#end if
	tword = word.title()
	if tword in word_freq:
		del word_freq[tword]
	#end if
#next word

#print('\n'.join(['%i %s' % (y, x) for x,y in list(word_freq.items())[:10000]]))
for x,y in word_freq.items():
	print('%i %s' % (y, x))

#for word, freq in word_freq.items()[:100]:
#	text.concordance(word)
#next word, freq

